#ifndef ASSORT_INC
#define ASSORT_INC


typedef double (* p_func)(double);

float max(float **, int, int);
float min(float **, int, int);
double mean(float **, int, int);
double mean_dbl(double **, int, int);
void scale_img(float **, int, int, float, float);
void absolute(float **, int, int);
void sqrt_img(float **, int N, int M);
void offset(float **, int, int, float);

void copy_ch_fl(unsigned char **, float **, int, int);
void copy_fl_ch(float **, unsigned char **, int, int);


double energy4_prec(float **img, int N, int M, float p);
double energy8_bod(float **img, int N, int M, float p);
double energy8_sup(float **img, int **mask, int N, int M, float p);
double energy8_sup_dbl(double **img, int **mask, int N, int M, double p);
double dp_energy8_toroid(float **img, int N, int M, float p);
double energy8_toroid(float **img, int N, int M, float p);
double energy8_toroid_dbl(double **img, int N, int M, float p);
double dcostp(float **img, int N, int M, float p);
double dcostp_sup(float **img, int **mask, int N, int M, int Nsup, float p);
double energy_logcosh(float **img, int N, int M, float sigma);
double energy_logcosh_toroid(float **img, int N, int M, float sigma);
double logcosh(double x);

double sq(double);

#endif
