#!/bin/sh

# Example1: Reconstruct mri phantom at 128 pix. resolution
#           using a constant initial condition

# reconstruct at lower resolution, 128 pixels, flat inital condition ('none'),
#   Gaussian MRF prior (p=2.0), 35 iterations (-i 35)
#   output is in file ex1_recon.mat, ground truth is data/mri_groundtruth.mat

../emisnew -i 35 -s 1.0 -p 2.0 -f 200 -r 128 ../data/mri_sino.mat none ex1_recon.mat


